<?php
/**
 * Theme Customizer Controls
 *
 * @package Jungle Eco Tours
 */

if ( ! function_exists( 'jungle_eco_tours_customizer_typography_setting_register' ) ) :
function jungle_eco_tours_customizer_typography_setting_register( $wp_customize ) {

    // Add Typography Panel for Body and Heading
    $wp_customize->add_panel(
        'jungle_eco_tours_typography_settings_panel',
        array(
            'priority'      => 30,
            'capability'    => 'edit_theme_options',
            'title'         => esc_html__( 'Typography Settings', 'jungle-eco-tours' ),
        )
    );

    // Section Body Typography
    $wp_customize->add_section(
        'jungle_eco_tours_body_typography_settings',
        array(
            'priority'      => 25,
            'capability'    => 'edit_theme_options',
            'title'         => esc_html__( 'Body', 'jungle-eco-tours' ),
            'panel'         => 'jungle_eco_tours_typography_settings_panel',
        )
    );

    // Body Font Family Setting
    $wp_customize->add_setting(
        'jungle_eco_tours_body_font_family',
        array(
            'default'           => 'Manrope, sans-serif', // Default font
            'sanitize_callback' => 'jungle_eco_tours_sanitize_font_family', // Custom sanitize function
        )
    );

    $wp_customize->add_control( new Jungle_Eco_Tours_Font_Select_Control(
    $wp_customize,
    'jungle_eco_tours_body_font_family',
    array(
        'label'   => esc_html__( 'Body Font Family', 'jungle-eco-tours' ),
        'section' => 'jungle_eco_tours_body_typography_settings',
        'choices' => jungle_eco_tours_get_google_fonts(),
    )
    ));


    // Section Heading Typography
    $wp_customize->add_section(
        'jungle_eco_tours_heading_typography_settings',
        array(
            'priority'      => 25,
            'capability'    => 'edit_theme_options',
            'title'         => esc_html__( 'Heading', 'jungle-eco-tours' ),
            'panel'         => 'jungle_eco_tours_typography_settings_panel',
        )
    );

    // Heading Font Family Setting
    $wp_customize->add_setting(
        'jungle_eco_tours_heading_font_family',
        array(
            'default'           => 'Manrope, sans-serif', // Default font
            'sanitize_callback' => 'jungle_eco_tours_sanitize_font_family', // Custom sanitize function
        )
    );

    $wp_customize->add_control( new Jungle_Eco_Tours_Font_Select_Control(
    $wp_customize,'jungle_eco_tours_heading_font_family',
    array(
        'label'   => esc_html__( 'Heading Font Family', 'jungle-eco-tours' ),
        'section' => 'jungle_eco_tours_heading_typography_settings',
        'choices' => jungle_eco_tours_get_google_fonts(),
    )
    ));
}
endif;

add_action( 'customize_register', 'jungle_eco_tours_customizer_typography_setting_register' );

// Function to fetch Google Fonts
function jungle_eco_tours_get_google_fonts() {
    // Add Google Fonts to be available for selection
    return array(
        'Manrope, sans-serif' => 'Manrope',
        'Amatic SC, sans-serif' => 'Amatic SC',
        'Raleway, sans-serif' => 'Raleway',
        'Arial, sans-serif'   => 'Arial',
        'Georgia, serif'      => 'Georgia',
        'Verdana, sans-serif' => 'Verdana',
        'Times New Roman, serif' => 'Times New Roman',
        'Roboto, sans-serif'  => 'Roboto',
        'Open Sans, sans-serif' => 'Open Sans',
        'Lora, serif'         => 'Lora',
        'Merriweather, serif' => 'Merriweather',
        'Montserrat, sans-serif' => 'Montserrat',
        // Add more Google fonts as needed
    );
}

// Sanitize Google Fonts input
function jungle_eco_tours_sanitize_font_family( $value ) {
    $jungle_eco_tours_allowed_fonts = array('Manrope, sans-serif','Amatic SC, sans-serif','Raleway, sans-serif','Arial, sans-serif', 'Georgia, serif', 'Verdana, sans-serif','Times New Roman, serif', 'Roboto, sans-serif', 'Open Sans, sans-serif','Lora, serif', 'Merriweather, serif', 'Montserrat, sans-serif',
        // Add more allowed fonts to this array
    );

    if ( in_array( $value, $jungle_eco_tours_allowed_fonts ) ) {
        return $value;
    } else {
        return 'Manrope, sans-serif'; // Default fallback font
    }
}

function jungle_eco_tours_sanitize_title( $value ) {
    return sanitize_text_field( $value );
}
